Yektanet/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('advertiser/', include('advertiser_management.urls')),
    path('admin/', admin.site.urls),
]

advertiser_management/urls.py
from django.urls import path

from . import views

app_name = 'advertiser_management'
urlpatterns = [
    path('', views.AdvertiserListView.as_view(), name='index'),
    path('report/', views.AdReportView.as_view(), name='report'),
    path('create/', views.AdCreateView.as_view(), name='create'),
    path('click/<int:ad_id>/', views.AdClickRedirectView.as_view(), name='ad_click'),
]

advertiser_management/models.py
from django.db import models, transaction

class Advertiser(models.Model):
	name = models.CharField(max_length=200)
	def __str__(self):
		return self.name

class Ad(models.Model):
	advertiser = models.ForeignKey(Advertiser, on_delete=models.CASCADE)
	title = models.CharField(max_length=200)
	img_url = models.URLField(max_length=200)
	link = models.URLField(max_length=200)
	approved = models.BooleanField(default=False)
	def __str__(self):
		return self.title

class Click(models.Model):
	ad = models.ForeignKey(Ad, on_delete=models.CASCADE)
	date = models.DateTimeField('date clicked')
	ip_address = models. GenericIPAddressField()
	def __str__(self):
		return self.ad.title

class View(models.Model):
	ad = models.ForeignKey(Ad, on_delete=models.CASCADE)
	date = models.DateTimeField('date viewed')
	ip_address = models. GenericIPAddressField()
	def __str__(self):
		return self.ad.title

advertiser_management/forms.py
from django import forms

from .models import *

class CreateAdForm(forms.ModelForm):

	advertiser = forms.ModelChoiceField(
		queryset=Advertiser.objects.all(), 
		widget=forms.Select(
			attrs={'class': 'form-control'}
	))

	img_url = forms.URLField(
		widget=forms.TextInput(
			attrs={'placeholder': 'Image URL', 'class': 'form-control'}
	))

	title = forms.CharField(
		widget=forms.TextInput(
			attrs={'placeholder': 'Title', 'class': 'form-control'}
	))

	link = forms.URLField(
		widget=forms.TextInput(
			attrs={'placeholder': 'Link URL', 'class': 'form-control'}
	))
	class Meta:
		model = Ad
		fields = ['advertiser', 'img_url', 'title', 'link']

advertiser_management/views.py
from django.shortcuts import get_object_or_404
from django.urls import reverse
from django.utils import timezone
from django.views.generic import CreateView, ListView, RedirectView, TemplateView
from django.db.models import Count, Func, Avg, Max, F, Q, ExpressionWrapper, DurationField, FloatField
from django.db.models import Subquery, OuterRef, fields

from django.db.models.functions import ExtractHour, Coalesce

from .models import *
from .forms import CreateAdForm

import datetime

class AdvertiserListView(ListView):
	model = Advertiser
	template_name = "advertiser_management/ads.html"
	context_object_name = 'advertisers'
	def get_queryset(self):
		return super().get_queryset()

	def create_views(self, advertisers):
		for advertiser in advertisers:
			for ad in advertiser.approved_adds:
				view = View(ad=ad, date=timezone.now(), ip_address=self.request.ip_address)
				view.save()

	def get_context_data(self, **kwargs):
		context = super().get_context_data(**kwargs)
		advertisers = context['advertisers']
		for advertiser in advertisers:
			advertiser.approved_adds = advertiser.ad_set.filter(approved=True)
		self.create_views(advertisers)
		return context

class AdClickRedirectView(RedirectView):
	permanent = True

	def get_redirect_url(self, *args, **kwargs):
		ad = get_object_or_404(Ad, pk=kwargs['ad_id'])
		self.create_click(ad)
		return ad.link

	def create_click(self, ad):
		click = Click(ad=ad, date=timezone.now(), ip_address=self.request.ip_address)
		click.save()

class AdCreateView(CreateView):
	model = Ad
	form_class = CreateAdForm
	def get_success_url(self):
		return reverse('advertiser_management:index')

class AdReportView(TemplateView):
	template_name = 'advertiser_management/report.html'

	def get_context_data(self, **kwargs):
		context = super().get_context_data(**kwargs)

		context['total'] = Ad.objects.annotate(
			click_count=Count('click', distinct = True),
			view_count=Count('view', distinct = True),
			click_rate=100 * Count('click', distinct = True) / Count('view', distinct = True),
		).order_by('-click_rate')
		
		context['hourly'] = Ad.objects.annotate(
			hour=ExtractHour('view__date'),
			click_count=Count('click', filter=Q(click__date__hour=ExtractHour('view__date')), distinct = True),
			view_count=Count('view', distinct=True),
			click_rate=100 * Count('click', filter=Q(click__date__hour=ExtractHour('view__date')), distinct=True) / Count('view', distinct=True),
		).order_by('id', 'hour')

		ads = Ad.objects.all()
		for ad_itr in ads:
			time_sum = 0
			cnt = 0
			for click in Click.objects.filter(ad=ad_itr).all():
				view_time = None
				for view in View.objects.filter(ad=ad_itr, ip_address=click.ip_address).annotate():
					if view.date < click.date and (not view_time or view_time < view.date):
						view_time = view.date
				if view_time:
					cnt += 1
					time_sum += (click.date - view_time).total_seconds()
			ad_itr.avg_time = (time_sum / cnt) if cnt > 0 else None
		context['diffs'] = ads

		return context

		'''ads = Ad.objects.filter(click__isnull=False, view__isnull=False).annotate(
			avg_time=Avg(
				Coalesce(Func(F('click__date'), function='strftime', template='%s'), 0) - Coalesce(
					Subquery(
						View.objects.filter(
							ad=OuterRef('pk'),
							ip_address=OuterRef('click__ip_address'),
							date__lt=OuterRef('click__date')
						).order_by('-date')[:1].values('date').annotate(
							unix_timestamp=Func(F('date'), function='strftime', template='%s')
						).values('unix_timestamp')
					), 0
				), output_field=FloatField()
			)
		)
		context['diffs'] = ads

		return context'''

advertiser_management/templates/advertiser_management/ad_form.html
<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Create Ad</title>
</head>
<body>
	<form action="{% url 'advertiser_management:create' %}" method="post">
		{% csrf_token %}
		{{ form.as_p }}
		<input type="submit" value="Save">
	</form>
</body>
</html>

advertiser_management/templates/advertiser_management/ads.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
          crossorigin="anonymous">
    <title>Ad View</title>
</head>
<body>
<div class="container" dir="rtl">
    {% for advertiser in advertisers %}
        <div class="card mt-2 p-2">
            <h5 class="card-title">{{ advertiser.name }}</h5>
            <div class="card-body">
                <div class="row">
		    {% for ad in advertiser.approved_adds %}
		        <div class="card col-md-2 p-0 mx-2">
		            <a href="/advertiser/click/{{ ad.id }}/">
		                <img src="{{ ad.img_url }}"
		                     class="card-img-top">
		                <div class="card-body">
		                    <span>{{ ad.title }}</span>
		                </div>
		            </a>
		        </div>
		    {% endfor %}
                </div>
            </div>
        </div>
    {% endfor %}
</div>
</body>
</html>

advertiser_management/templates/advertiser_management/report.html
<title>Ad Report</title>

<style type="text/css">
	body {
		padding: 20px;
	}

	table {
		border-collapse: collapse;
		width: 100%;
		border: 1px solid black;
	}

	th, td {
		text-align: left;
		padding: 10px;
	}

	th {
		background-color: #333;
		color: white;
	}

	tr:nth-child(even) {
		background-color: #f2f2f2;
	}

</style>

<h2>Total clicks and views</h2>
<table>
  <thead>
    <tr>
      <th>Ad</th>
      <th>Advertiser</th>
      <th>Clicks</th>
      <th>Views</th>
      <th>Click Rate</th>
    </tr>
  </thead>
  <tbody>
    {% for ad in total %}
    <tr>
      <td>{{ ad.title }}</td>
      <td>{{ ad.advertiser }}</td>
      <td>{{ ad.click_count }}</td>
      <td>{{ ad.view_count }}</td>
      <td>{{ ad.click_rate }}</td>
    </tr>
    {% endfor %}
  </tbody>
</table>

<h2>Hourly clicks and views</h2>
<table>
  <thead>
    <tr>
      <th>Ad</th>
      <th>Hour</th>
      <th>Clicks</th>
      <th>Views</th>
      <th>Click Rate</th>
    </tr>
  </thead>
  <tbody>
    {% for ad in hourly %}
    <tr>
      <td>{{ ad.title }}</td>
      <td>{{ ad.hour }}</td>
      <td>{{ ad.click_count }}</td>
      <td>{{ ad.view_count }}</td>
      <td>{{ ad.click_rate }}</td>
    </tr>
    {% endfor %}
  </tbody>
</table>

<h2>Average Time Difference</h2>
<table>
  <thead>
    <tr>
      <th>Ad</th>
      <th>Average Time Difference</th>
    </tr>
  </thead>
  <tbody>
    {% for diff in diffs %}
    <tr>
      <td>{{ diff.title }}</td>
      <td>{{ diff.avg_time }}</td>
    </tr>
    {% endfor %}
  </tbody>
</table>